# HTTPS client for UPS
# Requires: M2Crypto
from M2Crypto import Rand, SSL, httpslib
import urllib
from xml.dom.minidom import parse, parseString
def HTTPSRequest (server,port,action,method,params,urlencode_params=0):
    ctx = SSL.Context()
    h = httpslib.HTTPSConnection(server, port, ssl_context=ctx)
    h.set_debuglevel(1)
    headers = {"Content-type": "application/x-www-form-urlencoded",
               "Accept": "text/xml"}
    if urlencode_params:
        h.request(method,action,urllib.urlencode(params), headers)
    else:
        h.request(method,action,params, headers)
    response = h.getresponse()
    print response.status, response.reason
    data = response.read()
    h.close()
    #return (response.status,response.reason,data)
    try:
    	dom = parseString(data)
    except:
	dom=None
    return (response.status,response.reason,dom)


if __name__=='__main__':
    print HTTPSRequest('zope.redg.us',443,'/','POST','')
    
