import sys, time, urllib, socket, random
from string import split

def confirmPayment(self):
    """Ask PayPal to confirm this payment, return status and detail strings"""

    dict = {}
    for key,value in self.REQUEST.form.items():
        dict[key]=value
    paymentDetails =  urllib.urlencode(dict)

    confirmPostData = paymentDetails + '&cmd=_notify-validate'

    #s=socket.socket(AF_INET,SOCK_STREAM)
    #try:
    #    s.connect("www.eliteweaver.co.uk",80)
    #except:
    #    print "Problem: Error Number: %s Error String: %s" % (errno,mesg)
    #    return

    #header = "POST /cgi-bin/IPNtestbed.exe/initiate HTTP/1.0\r\n"
    #header = header+"Host: www.optioninsight.com\r\n" # Host on Shared IP

    ##header = "POST /testing/ipntest.php HTTP/1.0\r\n"
    ##header = header+"Host: www.eliteweaver.co.uk\r\n" # Host on Shared IP
    #header = header+"Content-Type: application/x-www-form-urlencoded\r\n"
    #header = header+"Content-Length: "+len(confirmPostData)+"\r\n\r\n"

    #s.send(header+confirmPostData)

    #paymentStatus = s.recv(1024)
    #if paymentStatus == 'VERIFIED':
    #   pass


    # this is a real paypalipn url
    confirmPostRequest = urllib.urlopen('http://www.paypal.com/cgi-bin/webscr', confirmPostData)

    # this is test paypalipn url (do not delete!)
    #confirmPostRequest = urllib.urlopen('http://www.eliteweaver.co.uk/testing/ipntest.php', confirmPostData)

    # this is test paypalipn url (do not delete!)
    #confirmPostRequest = urllib.urlopen('http://www.optioninsight.com/cgi-bin/IPNtestbed.exe/initiate', confirmPostData)

    paymentStatus = confirmPostRequest.read() # either VERIFIED or INVALID
    return paymentStatus, paymentDetails

def send_email(self,msg):
    message = """
Hello
    
This email was sent automatically by PayPal Instant Payment Notification script.
"""
    message = message + msg
    
    server = smtplib.SMTP('localhost',25)
    #server.set_debuglevel(1)
    for mystore in self.sql.MyStore():
        server.sendmail('From: '+mystore.from_email+'\r\n','To: 'mystore.from_email+'\r\n\r\n',message)
    server.quit()

def logPayment(self,paymentStatus, paymentDetails):
    """Write payment status and details to a log file"""

    # here we define what orders it was paid for
    orders_paid=split(self.REQUEST['custom'])

    if paymentStatus == 'VERIFIED':

        if self.REQUEST['payment_status']=='completed' or self.REQUEST['payment_status']=='pending':
            # Steps from paypal.com
	    # 1. Perform the "Notification Validation" below
            # 2. Confirm that "payment_status" is "Completed"
            # 3. Check "txn_id" against prior transactions to prevent duplicate processing
            # 4. Confirm that "receiver_email" is an email address registered in your PayPal account

            # check receiver_email
            for payment in self.sql.PaymentTypes(zope_function_name='PayPal',language_id=1):
                for payment_var in self.sql.PaymentTypeVars(payment_type_id=payment.payment_type_id,var_name='business',language_id=1):
		    if payment_var.value!=self.REQUEST['receiver_email']:
			msg='The receiver_email is not coincide to your email as merchant! Order(s): '+self.REQUEST['custom']
                        send_email(msg)
                        return

            # check that amount of order is correct
            # if it's wrong then send email to owner

            for currency in self.sql.Currencies(code=self.REQUEST['mc_currency'],language_id=1):
                total_sum=0.0
                orders_currency_id=0
                orders_customer_id=0
                for order_paid in orders_paid:
                    for order in self.sql.Orders(order_id=order_paid,language_id=1):
                        total_sum=total_sum+order.price_total_decimal
                        orders_currency_id=order.currency_id
                        orders_customer_id=order.customer_id

                if self.format_price(self.REQUEST['mc_gross'],currency.currency_id)!=format_price(total_sum,orders_currency_id):
                        msg='The amount paid is not currect for the order(s): '+self.REQUEST['custom']+' !'
                        send_email(msg)
	                return

            # create random number for session
            r_s=''
            for i in range(0,10):
            r_s=r_s+random.choice('abcdefghjkmnpqrstuvwxyz123456789ABCDEFGHJKLMNPQRSTUVWXYZ')

            # update all info and send emails
            if self.REQUEST['payment_status']=='completed':
                self.REQUEST.SESSION.set(r_s+'.order_status_type_id',3)
                
                #save into Log transaction_id
                self.sql.PaymentResponseLogAdd(
                    orders_unique_keys=self.REQUEST['custom'],
                    customer_id=orders_customer_id,
                    response='transactionID: '+self.REQUEST['txn_id']
                )

            for payment in self.sql.PaymentTypes(zope_function_name='PayPal',language_id=1):
                self.REQUEST.SESSION.set(r_s+'.orders_payment_type',payment.payment_type_id)
            self.REQUEST.SESSION.set(r_s+'.orders_to_pay',orders_paid)
            self.checkoutProcess(self,r_s=r_s)
        else:
            #possible that it's after pending so we need to return back data
            for order_ paid in orders_paid:
                for order in self.sql.Orders(order_unique_key=order_paid,language_id=1):
                    for order_item in self.sql.OrdersItems(order_id=order_id,language_id=1):
                        for product in self.sql.AvProducts(av_product_id=order_item.av_product_id,language_id=1):
                            # update quantity in product table
                            new_quantity = product.qt+order_item.quantity
                            available_since='NULL'
                            available_until='NULL'
                            if product.available_since is not None:
                                available_since=product.available_since
                            if product.available_until is not None:
                                available_until=product.available_until
                            self.sql.AvProductUpdate(
                                av_product_id=product.av_product_id,
                                reseller_id=product.reseller_id,
                                qt=new_quantity,
                                price=product.price,
                                price_currency_id=product.price_currency_id,
                                available_since=available_since,
                                weight=product.weight,
                                options=product.options,
                                tax_class_id=product.tax_class_id,
                                fixed_tax=product.fixed_tax,
                                available_until=available_until)


                    # update table orders: set status=0
                    self.sql.OrdersUpdate(
                        order_name=order.order_name,
                        order_status_type_id=0,
                        gender=order.gender,
                        first_name=order.first_name,
                        last_name=order.last_name,
                        ship_to_name=order.ship_to_name,
                        shipment_type=order.shipment_type,
                        payment_zope_name=order.payment_zope_name,
                        payment_name_mlid=order.payment_name_mlid,
                        price_subtotal=order.price_subtotal,
                        price_tax=order.price_tax,
                        price_shipping=order.price_shipping,
                        price_total=order.price_total,
                        currency_id=order.currency_id,
                        language_id=order.language_id,
                        order_id=order_id)
            
    elif paymentStatus == 'INVALID':
        # something's wrong
        msg='PayPal sent INVALID status to the order(s): '+self.REQUEST['custom']
        send_email(msg)

    #logFile = open('/home/victor/test.log', 'a')
    #logFile.write('%s %s %s\n' % (time.ctime(time.time()), paymentStatus, paymentDetails))
    #logFile.close()
    return 1

def paypalipn(self):
    paymentStatus, paymentDetails = confirmPayment(self)
    logPayment(self,paymentStatus, paymentDetails)
    return 'foo'
